// package: typedb.protocol
// file: cluster/cluster_service.proto

/* tslint:disable */
/* eslint-disable */

import * as grpc from "@grpc/grpc-js";
import {handleClientStreamingCall} from "@grpc/grpc-js/build/src/server-call";
import * as cluster_cluster_service_pb from "../cluster/cluster_service_pb";
import * as cluster_cluster_server_pb from "../cluster/cluster_server_pb";
import * as cluster_cluster_database_pb from "../cluster/cluster_database_pb";

interface ITypeDBClusterService extends grpc.ServiceDefinition<grpc.UntypedServiceImplementation> {
    servers_all: ITypeDBClusterService_Iservers_all;
    databases_get: ITypeDBClusterService_Idatabases_get;
    databases_all: ITypeDBClusterService_Idatabases_all;
}

interface ITypeDBClusterService_Iservers_all extends grpc.MethodDefinition<cluster_cluster_server_pb.ServerManager.All.Req, cluster_cluster_server_pb.ServerManager.All.Res> {
    path: "/typedb.protocol.TypeDBCluster/servers_all";
    requestStream: false;
    responseStream: false;
    requestSerialize: grpc.serialize<cluster_cluster_server_pb.ServerManager.All.Req>;
    requestDeserialize: grpc.deserialize<cluster_cluster_server_pb.ServerManager.All.Req>;
    responseSerialize: grpc.serialize<cluster_cluster_server_pb.ServerManager.All.Res>;
    responseDeserialize: grpc.deserialize<cluster_cluster_server_pb.ServerManager.All.Res>;
}
interface ITypeDBClusterService_Idatabases_get extends grpc.MethodDefinition<cluster_cluster_database_pb.ClusterDatabaseManager.Get.Req, cluster_cluster_database_pb.ClusterDatabaseManager.Get.Res> {
    path: "/typedb.protocol.TypeDBCluster/databases_get";
    requestStream: false;
    responseStream: false;
    requestSerialize: grpc.serialize<cluster_cluster_database_pb.ClusterDatabaseManager.Get.Req>;
    requestDeserialize: grpc.deserialize<cluster_cluster_database_pb.ClusterDatabaseManager.Get.Req>;
    responseSerialize: grpc.serialize<cluster_cluster_database_pb.ClusterDatabaseManager.Get.Res>;
    responseDeserialize: grpc.deserialize<cluster_cluster_database_pb.ClusterDatabaseManager.Get.Res>;
}
interface ITypeDBClusterService_Idatabases_all extends grpc.MethodDefinition<cluster_cluster_database_pb.ClusterDatabaseManager.All.Req, cluster_cluster_database_pb.ClusterDatabaseManager.All.Res> {
    path: "/typedb.protocol.TypeDBCluster/databases_all";
    requestStream: false;
    responseStream: false;
    requestSerialize: grpc.serialize<cluster_cluster_database_pb.ClusterDatabaseManager.All.Req>;
    requestDeserialize: grpc.deserialize<cluster_cluster_database_pb.ClusterDatabaseManager.All.Req>;
    responseSerialize: grpc.serialize<cluster_cluster_database_pb.ClusterDatabaseManager.All.Res>;
    responseDeserialize: grpc.deserialize<cluster_cluster_database_pb.ClusterDatabaseManager.All.Res>;
}

export const TypeDBClusterService: ITypeDBClusterService;

export interface ITypeDBClusterServer {
    servers_all: grpc.handleUnaryCall<cluster_cluster_server_pb.ServerManager.All.Req, cluster_cluster_server_pb.ServerManager.All.Res>;
    databases_get: grpc.handleUnaryCall<cluster_cluster_database_pb.ClusterDatabaseManager.Get.Req, cluster_cluster_database_pb.ClusterDatabaseManager.Get.Res>;
    databases_all: grpc.handleUnaryCall<cluster_cluster_database_pb.ClusterDatabaseManager.All.Req, cluster_cluster_database_pb.ClusterDatabaseManager.All.Res>;
}

export interface ITypeDBClusterClient {
    servers_all(request: cluster_cluster_server_pb.ServerManager.All.Req, callback: (error: grpc.ServiceError | null, response: cluster_cluster_server_pb.ServerManager.All.Res) => void): grpc.ClientUnaryCall;
    servers_all(request: cluster_cluster_server_pb.ServerManager.All.Req, metadata: grpc.Metadata, callback: (error: grpc.ServiceError | null, response: cluster_cluster_server_pb.ServerManager.All.Res) => void): grpc.ClientUnaryCall;
    servers_all(request: cluster_cluster_server_pb.ServerManager.All.Req, metadata: grpc.Metadata, options: Partial<grpc.CallOptions>, callback: (error: grpc.ServiceError | null, response: cluster_cluster_server_pb.ServerManager.All.Res) => void): grpc.ClientUnaryCall;
    databases_get(request: cluster_cluster_database_pb.ClusterDatabaseManager.Get.Req, callback: (error: grpc.ServiceError | null, response: cluster_cluster_database_pb.ClusterDatabaseManager.Get.Res) => void): grpc.ClientUnaryCall;
    databases_get(request: cluster_cluster_database_pb.ClusterDatabaseManager.Get.Req, metadata: grpc.Metadata, callback: (error: grpc.ServiceError | null, response: cluster_cluster_database_pb.ClusterDatabaseManager.Get.Res) => void): grpc.ClientUnaryCall;
    databases_get(request: cluster_cluster_database_pb.ClusterDatabaseManager.Get.Req, metadata: grpc.Metadata, options: Partial<grpc.CallOptions>, callback: (error: grpc.ServiceError | null, response: cluster_cluster_database_pb.ClusterDatabaseManager.Get.Res) => void): grpc.ClientUnaryCall;
    databases_all(request: cluster_cluster_database_pb.ClusterDatabaseManager.All.Req, callback: (error: grpc.ServiceError | null, response: cluster_cluster_database_pb.ClusterDatabaseManager.All.Res) => void): grpc.ClientUnaryCall;
    databases_all(request: cluster_cluster_database_pb.ClusterDatabaseManager.All.Req, metadata: grpc.Metadata, callback: (error: grpc.ServiceError | null, response: cluster_cluster_database_pb.ClusterDatabaseManager.All.Res) => void): grpc.ClientUnaryCall;
    databases_all(request: cluster_cluster_database_pb.ClusterDatabaseManager.All.Req, metadata: grpc.Metadata, options: Partial<grpc.CallOptions>, callback: (error: grpc.ServiceError | null, response: cluster_cluster_database_pb.ClusterDatabaseManager.All.Res) => void): grpc.ClientUnaryCall;
}

export class TypeDBClusterClient extends grpc.Client implements ITypeDBClusterClient {
    constructor(address: string, credentials: grpc.ChannelCredentials, options?: Partial<grpc.ClientOptions>);
    public servers_all(request: cluster_cluster_server_pb.ServerManager.All.Req, callback: (error: grpc.ServiceError | null, response: cluster_cluster_server_pb.ServerManager.All.Res) => void): grpc.ClientUnaryCall;
    public servers_all(request: cluster_cluster_server_pb.ServerManager.All.Req, metadata: grpc.Metadata, callback: (error: grpc.ServiceError | null, response: cluster_cluster_server_pb.ServerManager.All.Res) => void): grpc.ClientUnaryCall;
    public servers_all(request: cluster_cluster_server_pb.ServerManager.All.Req, metadata: grpc.Metadata, options: Partial<grpc.CallOptions>, callback: (error: grpc.ServiceError | null, response: cluster_cluster_server_pb.ServerManager.All.Res) => void): grpc.ClientUnaryCall;
    public databases_get(request: cluster_cluster_database_pb.ClusterDatabaseManager.Get.Req, callback: (error: grpc.ServiceError | null, response: cluster_cluster_database_pb.ClusterDatabaseManager.Get.Res) => void): grpc.ClientUnaryCall;
    public databases_get(request: cluster_cluster_database_pb.ClusterDatabaseManager.Get.Req, metadata: grpc.Metadata, callback: (error: grpc.ServiceError | null, response: cluster_cluster_database_pb.ClusterDatabaseManager.Get.Res) => void): grpc.ClientUnaryCall;
    public databases_get(request: cluster_cluster_database_pb.ClusterDatabaseManager.Get.Req, metadata: grpc.Metadata, options: Partial<grpc.CallOptions>, callback: (error: grpc.ServiceError | null, response: cluster_cluster_database_pb.ClusterDatabaseManager.Get.Res) => void): grpc.ClientUnaryCall;
    public databases_all(request: cluster_cluster_database_pb.ClusterDatabaseManager.All.Req, callback: (error: grpc.ServiceError | null, response: cluster_cluster_database_pb.ClusterDatabaseManager.All.Res) => void): grpc.ClientUnaryCall;
    public databases_all(request: cluster_cluster_database_pb.ClusterDatabaseManager.All.Req, metadata: grpc.Metadata, callback: (error: grpc.ServiceError | null, response: cluster_cluster_database_pb.ClusterDatabaseManager.All.Res) => void): grpc.ClientUnaryCall;
    public databases_all(request: cluster_cluster_database_pb.ClusterDatabaseManager.All.Req, metadata: grpc.Metadata, options: Partial<grpc.CallOptions>, callback: (error: grpc.ServiceError | null, response: cluster_cluster_database_pb.ClusterDatabaseManager.All.Res) => void): grpc.ClientUnaryCall;
}
